Program Euler;
Uses CRT;
Const N = 9;
M: array [1..N, 1..N] of boolean =
((False, True,  True,  False, False, False, False, False, False),
 (True,  False, True,  False, False, False, True,  True,  False),
 (True,  True,  False, True,  True,  False, False, False, False),
 (False, False, True,  False, True,  False, False, False, False),
 (False, False, True,  True,  False, True,  False, True,  False),
 (False, False, False, False, True,  False, True,  True,  True ),
 (False, True,  False, False, False, True,  False, True,  True ),
 (False, True,  False, False, True,  True,  True,  False, False),
 (False, False, False, False, False, True,  True,  False, False));
Type
  list = ^node;
  node = record
    i: integer;
    next: list;
  end;
Var
  stack1, stack2:        list;
  v, u, x, i, j:      integer;
  count: array [1..N] of byte;
Procedure Push(x: integer; var stack: list);
Var
  temp: list;
Begin
  New(temp);
  temp^.i:=x;
  temp^.next:=stack;
  stack:=temp;
End;
Procedure Pop(var x: integer; var stack: list);
Begin
  x:=stack^.i;
  stack:=stack^.next
End;
Function Peek(stack: list): integer;
Begin
  Peek:=stack^.i
End;
Procedure PrintList(l: list);
Begin
  If l=nil then
  begin
    writeln('訡!');
    exit;
  end;
  write('஢ 横: ');
  While l<>nil do
  Begin
    Write(l^.i,'-');
    l:=l^.next;
  End;
End;
Begin
  clrscr;
  TextColor(14);
  for i:=1 to N do
  begin
    count[i]:=0;
    for j:=1 to N do if m[i,j] = True then inc(count[i]);
    if (count[i] mod 2)<>0 then
    begin
      writeln(' 横');
      readkey;
      halt;
    end;
  end;
  stack1:=nil;
  stack2:=nil;
  Write('砫쭠 設: '); readln(v);
  if (v<=N) then Push(v, stack1);
  While stack1<>NIL do
  Begin
    v:=peek(stack1);
    i:=1;
    While (i<=n) and not m[v,i] do inc(i);
    If i<=n then
    Begin
      u:=i;
      Push(u, stack1);
      m[v,u]:=False;
      m[u,v]:=False;
    End
    else
    Begin
      pop(x,stack1);
      push(x,stack2)
    End;
  End;
  PrintList(stack2);
  readkey;
End.